<?php
/*
 * --------------------------------------------------------------------------------
   Weblogicx India  - K2 Store
 * --------------------------------------------------------------------------------
 * @package		Joomla! 2.5x
 * @subpackage	K2 Store
 * @author    	Weblogicx India http://www.weblogicxindia.com
 * @copyright	Copyright (c) 2010 - 2015 Weblogicx India Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 * @link		http://weblogicxindia.com
 * --------------------------------------------------------------------------------
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
$action = JRoute::_('index.php?option=com_k2store&view=checkout');
?>

<div id="content">
  <h1><?php echo JText::_('K2STORE_CHECKOUT'); ?></h1>
  <div class="k2store checkout">
    <div id="checkout">
      <div class="checkout-heading"><?php echo JText::_('K2STORE_CHECKOUT_OPTIONS'); ?></div>
      <div class="checkout-content"></div>
    </div>
    <?php if (!$this->logged) { ?>
    <div id="billing-address">
      <div class="checkout-heading"><span><?php echo JText::_('K2STORE_CHECKOUT_ACCOUNT'); ?></span></div>
      <div class="checkout-content"></div>
    </div>
    <?php } else { ?>
    <div id="billing-address">
      <div class="checkout-heading"><span><?php echo JText::_('K2STORE_CHECKOUT_BILLING_ADDRESS');; ?></span></div>
      <div class="checkout-content"></div>
    </div>
    <?php } ?>
    <?php if ($this->showShipping) { ?>
    <div id="shipping-address">
      <div class="checkout-heading"><?php echo JText::_('K2STORE_CHECKOUT_SHIPPING_ADDRESS'); ?></div>
      <div class="checkout-content"></div>
    </div>
    <?php } ?>
    <div id="shipping-payment-method">
      <div class="checkout-heading">
      <?php if ($this->showShipping) : ?>
      <?php echo JText::_('K2STORE_CHECKOUT_SHIPPING_PAYMENT_METHOD'); ?>
      <?php else: ?>
      <?php echo JText::_('K2STORE_CHECKOUT_PAYMENT_METHOD'); ?>
      <?php endif;?>
      </div>
      <div class="checkout-content"></div>
    </div>
    <div id="confirm">
      <div class="checkout-heading"><?php echo JText::_('K2STORE_CHECKOUT_CONFIRM');; ?></div>
      <div class="checkout-content"></div>
    </div>
  </div>
  </div>
<script type="text/javascript"><!--

var query = {};
query['option']='com_k2store';
query['view']='checkout';

K2Store(document).on('change', '#checkout .checkout-content input[name=\'account\']', function() {
	if (K2Store(this).attr('value') == 'register') {
		K2Store('#billing-address .checkout-heading span').html('<?php echo JText::_('K2STORE_CHECKOUT_ACCOUNT'); ?>');
	} else {
		K2Store('#billing-address .checkout-heading span').html('<?php echo JText::_('K2STORE_CHECKOUT_BILLING_ADDRESS'); ?>');
	}
});

K2Store(document).on('click', '.checkout-heading a', function() {
	K2Store('.checkout-content').slideUp('slow');

	K2Store(this).parent().parent().find('.checkout-content').slideDown('slow');
});

//incase only guest checkout is allowed we got to process that first
<?php if((!$this->logged && $this->params->get('allow_guest_checkout')) && (!$this->params->get('show_login_form', 1) && !$this->params->get('allow_registration', 1))){ ?>

K2Store(document).ready(function() {
	K2Store('#billing-address .checkout-heading span').html('<?php echo JText::_('K2STORE_CHECKOUT_BILLING_ADDRESS'); ?>');
	K2Store('#checkout').hide();
	K2Store.ajax({
	url: 'index.php',
	type: 'post',
	data: 'option=com_k2store&view=checkout&task=guest',
	dataType: 'html',
	success: function(html) {
		K2Store('.warning, .k2error').remove();

		K2Store('#billing-address .checkout-content').html(html);

		K2Store('#checkout .checkout-content').slideUp('slow');

		K2Store('#billing-address .checkout-content').slideDown('slow');
	},
	error: function(xhr, ajaxOptions, thrownError) {
		alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
	}
});
});

<?php }elseif(!$this->logged) { ?>
K2Store(document).ready(function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: 'option=com_k2store&view=checkout&task=login',
		success: function(html) {
			K2Store('#checkout .checkout-content').html(html);

			K2Store('#checkout .checkout-content').slideDown('slow');
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});
<?php } else { ?>
K2Store(document).ready(function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: 'option=com_k2store&view=checkout&task=billing_address',
		dataType: 'html',
		success: function(html) {
			K2Store('#billing-address .checkout-content').html(html);

			K2Store('#billing-address .checkout-content').slideDown('slow');
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});
<?php } ?>

//new account
K2Store(document).on('click', '#button-account', function() {
		var task = K2Store('input[name=\'account\']:checked').attr('value');
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: 'option=com_k2store&view=checkout&task='+task,
		dataType: 'html',
		beforeSend: function() {
			K2Store('#button-account').attr('disabled', true);
			K2Store('#button-account').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-account').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(html) {
			K2Store('.warning, .k2error').remove();

			K2Store('#billing-address .checkout-content').html(html);

			K2Store('#checkout .checkout-content').slideUp('slow');

			K2Store('#billing-address .checkout-content').slideDown('slow');

			K2Store('.checkout-heading a').remove();

			K2Store('#checkout .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});


//Login
K2Store(document).on('click', '#button-login', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#checkout #login :input'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-login').attr('disabled', true);
			K2Store('#button-login').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-login').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				K2Store('#checkout .checkout-content').prepend('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

				K2Store('.warning').fadeIn('slow');
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

// Register
K2Store(document).on('click', '#button-register', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#billing-address input[type=\'text\'], #billing-address input[type=\'password\'], #billing-address input[type=\'checkbox\']:checked, #billing-address input[type=\'radio\']:checked, #billing-address input[type=\'hidden\'], #billing-address select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-register').attr('disabled', true);
			K2Store('#button-register').after('<span class="wait">&nbsp;<img src="media/k2store/images/loading.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-register').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#billing-address .checkout-content').prepend('<div class="warning alert alert-block alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}

				if (json['error']['first_name']) {
					K2Store('#billing-address input[name=\'first_name\'] + br').after('<span class="k2error">' + json['error']['first_name'] + '</span>');
				}

				if (json['error']['last_name']) {
					K2Store('#billing-address input[name=\'last_name\'] + br').after('<span class="k2error">' + json['error']['last_name'] + '</span>');
				}

				if (json['error']['email']) {
					K2Store('#billing-address input[name=\'email\'] + br').after('<span class="k2error">' + json['error']['email'] + '</span>');
				}

				if (json['error']['phone_1']) {
					K2Store('#billing-address input[name=\'phone_1\'] + br').after('<span class="k2error">' + json['error']['phone_1'] + '</span>');
				}

				if (json['error']['company']) {
					K2Store('#billing-address input[name=\'company\'] + br').after('<span class="k2error">' + json['error']['company'] + '</span>');
				}

				if (json['error']['tax_number']) {
					K2Store('#billing-address input[name=\'tax_number\'] + br').after('<span class="k2error">' + json['error']['tax_number'] + '</span>');
				}

				if (json['error']['address_1']) {
					K2Store('#billing-address input[name=\'address_1\'] + br').after('<span class="k2error">' + json['error']['address_1'] + '</span>');
				}

				if (json['error']['city']) {
					K2Store('#billing-address input[name=\'city\'] + br').after('<span class="k2error">' + json['error']['city'] + '</span>');
				}

				if (json['error']['zip']) {
					K2Store('#billing-address input[name=\'zip\'] + br').after('<span class="k2error">' + json['error']['zip'] + '</span>');
				}

				if (json['error']['country']) {
					K2Store('#billing-address select[name=\'country_id\'] + br').after('<span class="k2error">' + json['error']['country'] + '</span>');
				}

				if (json['error']['zone']) {
					K2Store('#billing-address select[name=\'zone_id\'] + br').after('<span class="k2error">' + json['error']['zone'] + '</span>');
				}

				if (json['error']['password']) {
					K2Store('#billing-address input[name=\'password\'] + br').after('<span class="k2error">' + json['error']['password'] + '</span>');
				}

				if (json['error']['confirm']) {
					K2Store('#billing-address input[name=\'confirm\'] + br').after('<span class="k2error">' + json['error']['confirm'] + '</span>');
				}
			} else {
				<?php if ($this->showShipping) { ?>
				var shipping_address = K2Store('#billing-address input[name=\'shipping_address\']:checked').attr('value');

				if (shipping_address) {
					K2Store.ajax({
						url: 'index.php',
						type: 'post',
						data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
						dataType: 'html',
						success: function(html) {
							K2Store('#shipping-payment-method .checkout-content').html(html);

							K2Store('#billing-address .checkout-content').slideUp('slow');

							K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

							K2Store('#checkout .checkout-heading a').remove();
							K2Store('#billing-address .checkout-heading a').remove();
							K2Store('#shipping-address .checkout-heading a').remove();
							K2Store('#shipping-payment-method .checkout-heading a').remove();
							//K2Store('#payment-method .checkout-heading a').remove();

							K2Store('#shipping-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
							K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');

							K2Store.ajax({
								url: 'index.php?option=com_k2store&view=checkout&task=shipping_address',
								dataType: 'html',
								success: function(html) {
									K2Store('#shipping-address .checkout-content').html(html);
								},
								error: function(xhr, ajaxOptions, thrownError) {
									alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
								}
							});
						},
						error: function(xhr, ajaxOptions, thrownError) {
							alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
						}
					});
				} else {
					K2Store.ajax({
						url: 'index.php',
						type: 'post',
						data: 'option=com_k2store&view=checkout&task=shipping_address',
						dataType: 'html',
						success: function(html) {
							K2Store('#shipping-address .checkout-content').html(html);

							K2Store('#billing-address .checkout-content').slideUp('slow');

							K2Store('#shipping-address .checkout-content').slideDown('slow');

							K2Store('#checkout .checkout-heading a').remove();
							K2Store('#billing-address .checkout-heading a').remove();
							K2Store('#shipping-address .checkout-heading a').remove();
							K2Store('#shipping-payment-method .checkout-heading a').remove();
							//K2Store('#payment-method .checkout-heading a').remove();

							K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
						},
						error: function(xhr, ajaxOptions, thrownError) {
							alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
						}
					});
				}
				<?php } else { ?>
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-payment-method .checkout-content').html(html);

						K2Store('#billing-address .checkout-content').slideUp('slow');

						K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

						K2Store('#checkout .checkout-heading a').remove();
						K2Store('#billing-address .checkout-heading a').remove();
						//K2Store('#payment-method .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();

						K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
				<?php } ?>

				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=billing_address',
					dataType: 'html',
					success: function(html) {
						K2Store('#billing-address .checkout-content').html(html);

						K2Store('#billing-address .checkout-heading span').html('<?php echo JText::_('K2STORE_BILLING_ADDRESS'); ?>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

//billing address
K2Store(document).on('click', '#button-billing-address', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#billing-address input[type=\'text\'], #billing-address input[type=\'password\'], #billing-address input[type=\'checkbox\']:checked, #billing-address input[type=\'radio\']:checked, #billing-address input[type=\'hidden\'], #billing-address select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-billing-address').attr('disabled', true);
			K2Store('#button-billing-address').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-billing-address').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#billing-address .checkout-content').prepend('<div class="warning" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}

				if (json['error']['first_name']) {
					K2Store('#billing-address input[name=\'first_name\']').after('<span class="k2error">' + json['error']['first_name'] + '</span>');
				}

				if (json['error']['last_name']) {
					K2Store('#billing-address input[name=\'last_name\']').after('<span class="k2error">' + json['error']['last_name'] + '</span>');
				}

				if (json['error']['phone_1']) {
					K2Store('#billing-address input[name=\'phone_1\']').after('<span class="k2error">' + json['error']['phone_1'] + '</span>');
				}

				if (json['error']['company']) {
					K2Store('#billing-address input[name=\'company\']').after('<span class="k2error">' + json['error']['company'] + '</span>');
				}

				if (json['error']['tax_number']) {
					K2Store('#billing-address input[name=\'tax_number\']').after('<span class="k2error">' + json['error']['tax_number'] + '</span>');
				}

				if (json['error']['address_1']) {
					K2Store('#billing-address input[name=\'address_1\']').after('<span class="k2error">' + json['error']['address_1'] + '</span>');
				}

				if (json['error']['city']) {
					K2Store('#billing-address input[name=\'city\']').after('<span class="k2error">' + json['error']['city'] + '</span>');
				}

				if (json['error']['zip']) {
					K2Store('#billing-address input[name=\'zip\']').after('<span class="k2error">' + json['error']['zip'] + '</span>');
				}

				if (json['error']['country']) {
					K2Store('#billing-address select[name=\'country_id\']').after('<span class="k2error">' + json['error']['country'] + '</span>');
				}

				if (json['error']['zone']) {
					K2Store('#billing-address select[name=\'zone_id\']').after('<span class="k2error">' + json['error']['zone'] + '</span>');
				}
			} else {
				<?php if ($this->showShipping) { ?>
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_address',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-address .checkout-content').html(html);

						K2Store('#billing-address .checkout-content').slideUp('slow');

						K2Store('#shipping-address .checkout-content').slideDown('slow');

						K2Store('#billing-address .checkout-heading a').remove();
						K2Store('#shipping-address .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();
						//K2Store('#payment-method .checkout-heading a').remove();

						K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
				<?php } else { ?>
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-payment-method .checkout-content').html(html);

						K2Store('#billing-address .checkout-content').slideUp('slow');

						K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

						K2Store('#billing-address .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();

						K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
				<?php } ?>

				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=billing_address',
					dataType: 'html',
					success: function(html) {
						K2Store('#billing-address .checkout-content').html(html);
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

//Shipping Address
K2Store(document).on('click', '#button-shipping-address', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#shipping-address input[type=\'text\'], #shipping-address input[type=\'hidden\'], #shipping-address input[type=\'password\'], #shipping-address input[type=\'checkbox\']:checked, #shipping-address input[type=\'radio\']:checked, #shipping-address select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-shipping-address').attr('disabled', true);
			K2Store('#button-shipping-address').after('<span class="wait">&nbsp;<img src="media/k2store/images/loading.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-shipping-address').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#shipping-address .checkout-content').prepend('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}

				if (json['error']['first_name']) {
					K2Store('#shipping-address input[name=\'first_name\']').after('<span class="k2error">' + json['error']['first_name'] + '</span>');
				}

				if (json['error']['last_name']) {
					K2Store('#shipping-address input[name=\'last_name\']').after('<span class="k2error">' + json['error']['last_name'] + '</span>');
				}

				if (json['error']['phone_1']) {
					K2Store('#shipping-address input[name=\'phone_1\']').after('<span class="k2error">' + json['error']['phone_1'] + '</span>');
				}

				if (json['error']['company']) {
					K2Store('#shipping-address input[name=\'company\']').after('<span class="k2error">' + json['error']['company'] + '</span>');
				}

				if (json['error']['address_1']) {
					K2Store('#shipping-address input[name=\'address_1\']').after('<span class="k2error">' + json['error']['address_1'] + '</span>');
				}

				if (json['error']['city']) {
					K2Store('#shipping-address input[name=\'city\']').after('<span class="k2error">' + json['error']['city'] + '</span>');
				}

				if (json['error']['postcode']) {
					K2Store('#shipping-address input[name=\'postcode\']').after('<span class="k2error">' + json['error']['postcode'] + '</span>');
				}

				if (json['error']['country']) {
					K2Store('#shipping-address select[name=\'country_id\']').after('<span class="k2error">' + json['error']['country'] + '</span>');
				}

				if (json['error']['zone']) {
					K2Store('#shipping-address select[name=\'zone_id\']').after('<span class="k2error">' + json['error']['zone'] + '</span>');
				}
			} else {
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-payment-method .checkout-content').html(html);

						K2Store('#shipping-address .checkout-content').slideUp('slow');

						K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

						K2Store('#shipping-address .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();
						//K2Store('#payment-method .checkout-heading a').remove();

						K2Store('#shipping-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');

						K2Store.ajax({
							url: 'index.php',
							type: 'post',
							data: 'option=com_k2store&view=checkout&task=shipping_address',
							dataType: 'html',
							success: function(html) {
								K2Store('#shipping-address .checkout-content').html(html);
							},
							error: function(xhr, ajaxOptions, thrownError) {
								alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
							}
						});
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});

				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=billing_address',
					dataType: 'html',
					success: function(html) {
						K2Store('#billing-address .checkout-content').html(html);
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

//Guest
K2Store(document).on('click', '#button-guest', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#billing-address input[type=\'text\'], #billing-address input[type=\'checkbox\']:checked, #billing-address input[type=\'radio\']:checked, #billing-address input[type=\'hidden\'], #billing-address select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-guest').attr('disabled', true);
			K2Store('#button-guest').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-guest').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#billing-address .checkout-content').prepend('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}

				if (json['error']['first_name']) {
					K2Store('#billing-address input[name=\'first_name\'] + br').after('<span class="k2error">' + json['error']['first_name'] + '</span>');
				}

				if (json['error']['last_name']) {
					K2Store('#billing-address input[name=\'last_name\'] + br').after('<span class="k2error">' + json['error']['last_name'] + '</span>');
				}

				if (json['error']['email']) {
					K2Store('#billing-address input[name=\'email\'] + br').after('<span class="k2error">' + json['error']['email'] + '</span>');
				}

				if (json['error']['phone_1']) {
					K2Store('#billing-address input[name=\'phone_1\'] + br').after('<span class="k2error">' + json['error']['phone_1'] + '</span>');
				}

				if (json['error']['company']) {
					K2Store('#billing-address input[name=\'company\'] + br').after('<span class="k2error">' + json['error']['company'] + '</span>');
				}

				if (json['error']['tax_number']) {
					K2Store('#billing-address input[name=\'tax_number\'] + br').after('<span class="k2error">' + json['error']['tax_number'] + '</span>');
				}

				if (json['error']['address_1']) {
					K2Store('#billing-address input[name=\'address_1\'] + br').after('<span class="k2error">' + json['error']['address_1'] + '</span>');
				}

				if (json['error']['city']) {
					K2Store('#billing-address input[name=\'city\'] + br').after('<span class="k2error">' + json['error']['city'] + '</span>');
				}

				if (json['error']['zip']) {
					K2Store('#billing-address input[name=\'zip\'] + br').after('<span class="k2error">' + json['error']['zip'] + '</span>');
				}

				if (json['error']['country']) {
					K2Store('#billing-address select[name=\'country_id\'] + br').after('<span class="k2error">' + json['error']['country'] + '</span>');
				}

				if (json['error']['zone']) {
					K2Store('#billing-address select[name=\'zone_id\'] + br').after('<span class="k2error">' + json['error']['zone'] + '</span>');
				}
			} else {
				<?php if ($this->showShipping) { ?>
				var shipping_address = K2Store('#billing-address input[name=\'shipping_address\']:checked').attr('value');

				if (shipping_address) {
					K2Store.ajax({
						url: 'index.php',
						type: 'post',
						data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
						dataType: 'html',
						success: function(html) {
							K2Store('#shipping-payment-method .checkout-content').html(html);

							K2Store('#billing-address .checkout-content').slideUp('slow');

							K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

							K2Store('#billing-address .checkout-heading a').remove();
							K2Store('#shipping-address .checkout-heading a').remove();
							K2Store('#shipping-payment-method .checkout-heading a').remove();

							K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
							K2Store('#shipping-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');

							K2Store.ajax({
								url: 'index.php',
								type: 'post',
								data: 'option=com_k2store&view=checkout&task=guest_shipping',
								dataType: 'html',
								success: function(html) {
									K2Store('#shipping-address .checkout-content').html(html);
								},
								error: function(xhr, ajaxOptions, thrownError) {
									alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
								}
							});
						},
						error: function(xhr, ajaxOptions, thrownError) {
							alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
						}
					});
				} else {
					K2Store.ajax({
						url: 'index.php',
						type: 'post',
						data: 'option=com_k2store&view=checkout&task=guest_shipping',
						dataType: 'html',
						success: function(html) {
							K2Store('#shipping-address .checkout-content').html(html);

							K2Store('#billing-address .checkout-content').slideUp('slow');

							K2Store('#shipping-address .checkout-content').slideDown('slow');

							K2Store('#billing-address .checkout-heading a').remove();
							K2Store('#shipping-address .checkout-heading a').remove();
							K2Store('#shipping-payment-method .checkout-heading a').remove();
							//K2Store('#payment-method .checkout-heading a').remove();

							K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
						},
						error: function(xhr, ajaxOptions, thrownError) {
							alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
						}
					});
				}
				<?php } else { ?>
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-payment-method .checkout-content').html(html);

						K2Store('#billing-address .checkout-content').slideUp('slow');

						K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

						K2Store('#billing-address .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();

						K2Store('#billing-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
				<?php } ?>
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

// Guest Shipping
K2Store(document).on('click', '#button-guest-shipping', function() {
	K2Store.ajax({
		url: 'index.php?option=com_k2store&view=checkout&task=guest_shipping_validate',
		type: 'post',
		data: K2Store('#shipping-address input[type=\'text\'], #shipping-address select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-guest-shipping').attr('disabled', true);
			K2Store('#button-guest-shipping').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-guest-shipping').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#shipping-address .checkout-content').prepend('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}

				if (json['error']['first_name']) {
					K2Store('#shipping-address input[name=\'first_name\']').after('<span class="k2error">' + json['error']['first_name'] + '</span>');
				}

				if (json['error']['last_name']) {
					K2Store('#shipping-address input[name=\'last_name\']').after('<span class="k2error">' + json['error']['last_name'] + '</span>');
				}

				if (json['error']['company']) {
					K2Store('#shipping-address input[name=\'company\']').after('<span class="k2error">' + json['error']['company'] + '</span>');
				}


				if (json['error']['address_1']) {
					K2Store('#shipping-address input[name=\'address_1\']').after('<span class="k2error">' + json['error']['address_1'] + '</span>');
				}

				if (json['error']['city']) {
					K2Store('#shipping-address input[name=\'city\']').after('<span class="k2error">' + json['error']['city'] + '</span>');
				}

				if (json['error']['zip']) {
					K2Store('#shipping-address input[name=\'zip\']').after('<span class="k2error">' + json['error']['zip'] + '</span>');
				}

				if (json['error']['country']) {
					K2Store('#shipping-address select[name=\'country_id\']').after('<span class="k2error">' + json['error']['country'] + '</span>');
				}

				if (json['error']['zone']) {
					K2Store('#shipping-address select[name=\'zone_id\']').after('<span class="k2error">' + json['error']['zone'] + '</span>');
				}
				if (json['error']['phone_1']) {
					K2Store('#shipping-address input[name=\'phone_1\']').after('<span class="k2error">' + json['error']['phone_1'] + '</span>');
				}

				if (json['error']['phone_2']) {
					K2Store('#shipping-address input[name=\'phone_2\']').after('<span class="k2error">' + json['error']['phone_2'] + '</span>');
				}
			} else {
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=shipping_payment_method',
					dataType: 'html',
					success: function(html) {
						K2Store('#shipping-payment-method .checkout-content').html(html);

						K2Store('#shipping-address .checkout-content').slideUp('slow');

						K2Store('#shipping-payment-method .checkout-content').slideDown('slow');

						K2Store('#shipping-address .checkout-heading a').remove();
						K2Store('#shipping-payment-method .checkout-heading a').remove();

						K2Store('#shipping-address .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});

//shipping and payment methods
K2Store(document).on('click', '#button-payment-method', function() {
	K2Store.ajax({
		url: 'index.php',
		type: 'post',
		data: K2Store('#shipping-payment-method input[type=\'text\'], #shipping-payment-method input[type=\'hidden\'], #shipping-payment-method input[type=\'radio\']:checked, #shipping-payment-method input[type=\'checkbox\']:checked, #shipping-payment-method textarea, #shipping-payment-method select'),
		dataType: 'json',
		beforeSend: function() {
			K2Store('#button-payment-method').attr('disabled', true);
			K2Store('#button-payment-method').after('<span class="wait">&nbsp;<img src="media/k2store/images/loader.gif" alt="" /></span>');
		},
		complete: function() {
			K2Store('#button-payment-method').attr('disabled', false);
			K2Store('.wait').remove();
		},
		success: function(json) {
			K2Store('.warning, .k2error').remove();

			if (json['redirect']) {
				location = json['redirect'];
			} else if (json['error']) {
				if (json['error']['warning']) {
					K2Store('#shipping-payment-method .checkout-content').prepend('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

					K2Store('.warning').fadeIn('slow');
				}
			} else {
				K2Store.ajax({
					url: 'index.php',
					type: 'post',
					data: 'option=com_k2store&view=checkout&task=confirm',
					dataType: 'html',
					success: function(html) {
						K2Store('#confirm .checkout-content').html(html);

						K2Store('#shipping-payment-method .checkout-content').slideUp('slow');

						K2Store('#confirm .checkout-content').slideDown('slow');

						K2Store('#shipping-payment-method .checkout-heading a').remove();

						K2Store('#shipping-payment-method .checkout-heading').append('<a><?php echo JText::_('K2STORE_CHECKOUT_MODIFY'); ?></a>');
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		}
	});
});
//--></script>