<?php
/*
 * --------------------------------------------------------------------------------
   Weblogicx India  - K2 Store v 2.0
 * --------------------------------------------------------------------------------
 * @package		Joomla! 1.5x
 * @subpackage	K2 Store
 * @author    	Weblogicx India http://www.weblogicxindia.com
 * @copyright	Copyright (c) 2010 - 2015 Weblogicx India Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 * @link		http://weblogicxindia.com
 * --------------------------------------------------------------------------------
*/

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');
JLoader::register('K2Parameter', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2parameter.php');
		
class K2StorePrices 
{
		
	/**
	 * 
	 * @return unknown_type
	 */
	function getItemPrice(&$id) 
	{
		
		
		$mainframe = JFactory::getApplication();
				
		$item = K2StorePrices::_getK2Item($id);
		$pluginName = 'k2store';

		//get the item price and tax profile id
		$plugins = new K2Parameter($item->plugins, '', $pluginName);
		 $item_price = $plugins->get('item_price'); 
		 $item_taxid = $plugins->get('item_tax');
		
		//now get the tax
		
		if ($item_taxid) {
			$taxrate = K2StorePrices::_getTaxRate($item_taxid);
			$price = $item_price + ($item_price * $taxrate);
		} else {
			$price = $item_price;
		}
		//process the price for number format
		$price = K2StorePrices::number( $price, array( 'thousands'=>'' ) );  
		
		return $price;  
	}
	
	
	function getItemTax(&$id) {
		
		$item = K2StorePrices::_getK2Item($id);
		$pluginName = 'k2store';

		//get the item price and tax profile id
		$plugins = new K2Parameter($item->plugins, '', $pluginName);
		 $item_price = $plugins->get('item_price'); 
		 $item_taxid = $plugins->get('item_tax');
		 if ($item_taxid) {
			$taxrate = K2StorePrices::_getTaxRate($item_taxid);
			$item_tax = $item_price * $taxrate;
		  }	else {
			  $item_tax = 0;
			  
		  }
		return $item_tax;		
	}
	
	function _getTaxRate($taxid) {
		
		$db		=& JFactory::getDBO();
		$query= "SELECT tax_percent FROM #__k2store_taxprofiles WHERE id=".$taxid;
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	 function number($number, $options='' )
	{
		$config = &JComponentHelper::getParams('com_k2store');
        $options = (array) $options;
        
        $thousands = isset($options['thousands']) ? $options['thousands'] : $config->get('currency_thousands', ',');
        $decimal = isset($options['decimal']) ? $options['decimal'] : $config->get('currency_decimal', '.');
        $num_decimals = isset($options['num_decimals']) ? $options['num_decimals'] : $config->get('currency_num_decimals', '2');
		
		$return = number_format($number, $num_decimals, $decimal, $thousands);
		return $return;
	}
	
	function _getK2Item($id) {
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'tables');
		$item = & JTable::getInstance('K2Item', 'Table');
		$id = intval($id);
		$item->load($id);
		return $item;
	}
	
}

