<?php
/*
 * --------------------------------------------------------------------------------
   Weblogicx India  - K2 Store v 2.0 - Payment Plugin - Authorize.Net
 * --------------------------------------------------------------------------------
 * @package		Joomla! 1.5x
 * @subpackage	K2 Store
 * @author    	Weblogicx India http://www.weblogicxindia.com
 * @copyright	Copyright (c) 2010 - 2015 Weblogicx India Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 * @link		http://weblogicxindia.com
 * --------------------------------------------------------------------------------
*/

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'library'.DS.'plugins'.DS.'payment.php');

class plgK2StorePayment_authorizedotnet extends K2StorePaymentPlugin
{
	/**
	 * @var $_element  string  Should always correspond with the plugin's filename, 
	 *                         forcing it to be unique 
	 */
    var $_element    = 'payment_authorizedotnet';
    var $login_id    = '';
    var $tran_key    = '';
    var $_isLog      = false;
    
    function plgK2StorePayment_authorizedotnet(& $subject, $config) 
	{
		parent::__construct($subject, $config);
		$this->loadLanguage( '', JPATH_ADMINISTRATOR );
		
        $this->login_id = $this->_getParam( 'login_id' ); 
        $this->tran_key = $this->_getParam( 'tran_key' );
	}

    
    /**
     * @param $data     array       form post data
     * @return string   HTML to display
     */
    function _prePayment( $data )
    {
        // prepare the payment form
        $vars = new JObject();
        $vars->url = JRoute::_( "index.php?option=com_k2store&view=mycart" );
        $vars->order_id = $data['order_id'];
        $vars->orderpayment_id = $data['orderpayment_id'];
        $vars->orderpayment_amount = $data['orderpayment_amount'];
        $vars->orderpayment_type = $this->_element;
        
        $vars->cardtype = JRequest::getVar("cardtype");
        $vars->cardnum = JRequest::getVar("cardnum");
        $vars->cardexp = JRequest::getVar("cardexp");
        $vars->cardcvv = JRequest::getVar("cardcvv");
        $vars->cardnum_last4 = substr( JRequest::getVar("cardnum"), -4 );
        
        //lets check the values submitted
        
        $html = $this->_getLayout('prepayment', $vars);
        return $html;
    }
    
    /**
     * Processes the payment form
     * and returns HTML to be displayed to the user
     * generally with a success/failed message
     *  
     * @param $data     array       form post data
     * @return string   HTML to display
     */
    function _postPayment( $data )
    {
        // Process the payment        
        $vars = new JObject();
        
        $app =& JFactory::getApplication();
        $paction = JRequest::getVar( 'paction' );
        
        switch ($paction)
        {
            case 'process_recurring':
                // TODO Complete this
                // $this->_processRecurringPayment();
                $app->close();                  
              break;
            case 'process':
                $vars->message = $this->_process();
                $html = $this->_getLayout('message', $vars);
                 $html .= $this->_displayArticle();
              break;
            default:
                $vars->message = JText::_( 'K2STORE AUTHORIZEDOTNET MESSAGE INVALID ACTION' );
                $html = $this->_getLayout('message', $vars);
              break;
        }
        
        return $html;
    }
    
    /**
     * Prepares variables and 
     * Renders the form for collecting payment info
     * 
     * @return unknown_type
     */
    function _renderForm( $data )
    {
        $vars = new JObject();
        $vars->prepop = array();
        $vars->cctype_input   = $this->_cardTypesField();
        
        $html = $this->_getLayout('form', $vars);
        
        return $html;
    }
    
    /**
     * Verifies that all the required form fields are completed
     * if any fail verification, set 
     * $object->error = true  
     * $object->message .= '<li>x item failed verification</li>'
     * 
     * @param $submitted_values     array   post data
     * @return unknown_type
     */
    function _verifyForm( $submitted_values )
    {
        $object = new JObject();
        $object->error = false;
        $object->message = '';
        $user = JFactory::getUser();
 
        foreach ($submitted_values as $key=>$value) 
        {
            switch ($key) 
            {
                case "cardtype":
                    if (!isset($submitted_values[$key]) || !JString::strlen($submitted_values[$key])) 
                    {
                        $object->error = true;
                        $object->message .= "<li>".JText::_( "Authorizedotnet Card Type Invalid" )."</li>";
                    }
                  break;
                case "cardnum":
                    if (!isset($submitted_values[$key]) || !JString::strlen($submitted_values[$key])) 
                    {
                        $object->error = true;
                        $object->message .= "<li>".JText::_( "Authorizedotnet Card Number Invalid" )."</li>";
                    } 
                  break;
                case "cardexp":
                    if (!isset($submitted_values[$key]) || !JString::strlen($submitted_values[$key])) 
                    {
                        $object->error = true;
                        $object->message .= "<li>".JText::_( "Authorizedotnet Card Expiration Date Invalid" )."</li>";
                    } 
                  break;
                case "cardcvv":
                    if (!isset($submitted_values[$key]) || !JString::strlen($submitted_values[$key])) 
                    {
                        $object->error = true;
                        $object->message .= "<li>".JText::_( "Authorizedotnet Card CVV Invalid" )."</li>";
                    } 
                  break;
                default:
                  break;
            }
        }   
            
        return $object;
    }
	
    
    /**
     * Generates a dropdown list of valid CC types
     * @param $fieldname
     * @param $default
     * @param $options
     * @return unknown_type
     */
    function _cardTypesField( $field='cardtype', $default='', $options='' )
    {       
        $types = array();
        $types[] = JHTML::_('select.option', 'Visa', JText::_( "Visa" ) );
        $types[] = JHTML::_('select.option', 'Mastercard', JText::_( "Mastercard" ) );
        $types[] = JHTML::_('select.option', 'AmericanExpress', JText::_( "AmericanExpress" ) );
        $types[] = JHTML::_('select.option', 'Discover', JText::_( "Discover" ) );
        $types[] = JHTML::_('select.option', 'DinersClub', JText::_( "DinersClub" ) );
        $types[] = JHTML::_('select.option', 'JCB', JText::_( "JCB" ) );
        
        $return = JHTML::_('select.genericlist', $types, $field, $options, 'value','text', $default);
        return $return;
    }
    
    /**
     * Formats the value of the card expiration date
     * 
     * @param string $format
     * @param $value
     * @return string|boolean date string or false
     * @access protected
     */
    function _getFormattedCardExprDate($format, $value)
    {
        // we assume we received a $value in the format MMYY
        $month = substr($value, 0, 2);
        $year = substr($value, 2);
        
        if (strlen($value) != 4 || empty($month) || empty($year) || strlen($year) != 2) {
            return false;
        }
        
        $date = date($format, mktime(0, 0, 0, $month, 1, $year));
        return $date;
    }

    /**
     * Gets the gateway URL
     * 
     * @param string $type Simple or subscription
     * @return string
     * @access protected
     */
    function _getActionUrl($type = 'simple')
    {
        if ($type == 'simple') 
        {
            $url  = $this->params->get('sandbox') ? 'https://test.authorize.net/gateway/transact.dll' : 'https://secure.authorize.net/gateway/transact.dll';
        }
            else 
        {
            // recurring billing url
            $url = $this->params->get('sandbox') ? 'https://apitest.authorize.net/xml/v1/request.api' : 'https://api.authorize.net/xml/v1/request.api';         
        }
        
        return $url;
    }
    
    /**
     * Gets a value of the plugin parameter
     * 
     * @param string $name
     * @param string $default
     * @return string
     * @access protected
     */
    function _getParam($name, $default = '') 
    {
        $sandbox_param = "sandbox_$name";
        $sb_value = $this->params->get($sandbox_param);
        
        if ($this->params->get('sandbox') && !empty($sb_value)) {
            $param = $this->params->get($sandbox_param, $default);
        }
        else {
            $param = $this->params->get($name, $default);
        }
        
        return $param;
    }
    
    /**
     * Gets an existing user or creates a new one
     * 
     * @param array $submitted_values Data for a new user
     * @param int $user_id Existing user id (optional)
     * @return JUser object
     * @access protected
     */
    
    function _getAddressid($uid) {
		
		$db =& JFactory::getDBO();
        $q = 'SELECT id FROM #__k2store_address WHERE user_id = '.$db->Quote($db->getEscaped( $uid, true ),false);
        $db->setQuery($q);
        $address_id = $db->loadResult();
            
        if ($error = $db->getErrorMsg()) {
            JError::raiseError(500, $error);
            return false;
        }
        
        return $address_id;
		
		
	}
    
    
    /**
     * Processes the payment
     * 
     * This method process only real time (simple) payments
     * 
     * @return string
     * @access protected
     */
    function _process()
    {
        /*
         * perform initial checks 
         */
        if ( ! JRequest::checkToken() ) {
            return $this->_renderHtml( JText::_( 'Invalid Token' ) );
        }
        
        $data = JRequest::get('post');
        
        // get order information
        JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'tables' );
        $order = JTable::getInstance('Orders', 'Table');
        $order->load( $data['orderpayment_id'] );
        if ( empty($order->order_id) ) {
            return JText::_( 'Authorizedotnet Message Invalid Order' );
        }
         
        if ( empty($this->login_id)) {
            return JText::_( 'Authorizedotnet Message Missing Merchant Login ID' );
        }
        if ( empty($this->tran_key)) {
            return JText::_( 'Authorizedotnet Message Missing Transaction Key' );
        }
        
        // prepare the form for submission to auth.net
        $process_vars = $this->_getProcessVars($data);
        
        return $this->_processSimplePayment($process_vars);       
  
    }
    
    /**
     * Prepares parameters for the payment processing
     * 
     * @param object $data Post variables
     * @param string $auth_net_login_id
     * @param string $auth_net_tran_key
     * @return array
     * @access protected
     */
    function _getProcessVars($data)
    {
        $auth_net_login_id = $this->login_id; 
        $auth_net_tran_key = $this->tran_key;
        
        // testing values
        $DEBUGGING                  = 0;                # Display additional information to track down problems
        $TESTING                    = 0;                # Set the testing flag so that transactions are not live
        $ERROR_RETRIES              = 2;                # Number of transactions to post if soft errors occur
        
        // NOT to be changed
        $auth_x_delim_char          = "|";              # not to be changed
        
        // leave this alone too -- used to identify the payment type
        $auth_paymenttype           = $this->_element;
        
        // transaction info
        // TODO Add a param for cc/echeck/both?
        $auth_method                = "CC";                 // or ECHECK
            # ECHECK DATA           // see http://developer.authorize.net/guides/AIM/eCheck_Developer_Guide/Transaction_Data_Requirements.htm
            # x_bank_aba_code       // 9 digits     
            # x_bank_acct_num       // up to 20 digits
            # x_bank_acct_type      // CHECKING, BUSINESSCHECKING, SAVINGS
            # x_bank_name           // Up to 50
            # x_bank_acct_name      // up to 50
            # x_echeck_type         // ARC, BOC, CCD, PPD, TEL, WEB
            # x_bank_check_number   // Up to 15
            # x_recurring_billing   // required if x_echeck_type=WEB    //  TRUE, FALSE

        // joomla info
        $user =& JFactory::getUser();
        $submitted_email            = !empty($data['email']) ? $data['email'] : '';
        $auth_userid                = $user->id;
        $auth_useremail             = empty($user->id) ? $submitted_email : $user->email;
        
        // order info
        require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'utilities.php');
        JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'tables' );
        $order = JTable::getInstance('Orders', 'Table');
        $order->load( $data['orderpayment_id']);
        $orderinfo = JTable::getInstance('address', 'Table');
        $addressid = $this->_getAddressid($auth_userid);
        $orderinfo->load($addressid);

        $auth_description           = JText::_( "Order Number" ).": ".$order->order_id;
        $auth_amount                =  K2StoreUtilities::number( $order->orderpayment_amount, array( 'thousands'=>'', 'num_decimals'=>'2' ) );
        $auth_invoice_num           = $data['orderpayment_id'];
        
        // customer information
        $auth_fname                 = $orderinfo->first_name; //"Charles D.";
        $auth_lname                 = $orderinfo->last_name; // "Gaulle";
        $auth_address               = $orderinfo->address_1. " ".$orderinfo->address_2; 
                                                                                 //"342 N. Main Street #150";
        $auth_city                  = $orderinfo->city; //"Ft. Worth";
        $auth_state                 = $orderinfo->state; //"TX";
        $auth_zip                   = $orderinfo->zip; //"12345";
        $auth_country               = $orderinfo->country; // "US";
        $auth_card_num              = str_replace(" ", "", str_replace("-", "", $data['cardnum'] ) ); 
                                                                                 // "5424000000000015";
        $auth_exp_date              = $this->_getFormattedCardExprDate('my', $data['cardexp'] ); // "1209";
        $auth_cvv                   = $data['cardcvv']; //"";

        // put all values into an array
        $authnet_values             = array
        (
            "x_login"               => $auth_net_login_id,
            "x_version"             => "3.1",
            "x_delim_char"          => $auth_x_delim_char,
            "x_delim_data"          => "TRUE",
            "x_type"                => "AUTH_CAPTURE",
            "x_method"              => $auth_method,
            "x_tran_key"            => $auth_net_tran_key,
            "x_relay_response"      => "FALSE",
            "x_card_num"            => $auth_card_num,
            "x_exp_date"            => $auth_exp_date,
            "x_description"         => $auth_description,
            "x_amount"              => $auth_amount,
            "x_first_name"          => $auth_fname,
            "x_last_name"           => $auth_lname,
            "x_address"             => $auth_address,
            "x_city"                => $auth_city,
            "x_state"               => $auth_state,
            "x_zip"                 => $auth_zip,
            "x_country"             => $auth_country,
            "x_cust_id"             => $auth_userid,
            "x_email"               => $auth_useremail,
            "x_card_code"           => $auth_cvv,
            "x_invoice_num"         => $auth_invoice_num,
            "k2store_order_id"       => $data['order_id'],
            "k2store_orderpayment_id"    => $data['orderpayment_id'],
            "cardtype"              => $data['cardtype'],
            "email"                 => $auth_useremail,
        );
        
        return $authnet_values;
    }
    
    /**
     * Sends a request to the server using cURL
     * 
     * @param string $url
     * @param string $content
     * @param arrray $http_headers (optional)
     * @return string
     * @access protected 
     */
    function _sendRequest($url, $content, $http_headers = array())
    {
        $ch = curl_init($url); 
        
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
        
        if (is_array($http_headers) && count($http_headers)) {
            curl_setopt($ch, CURLOPT_HTTPHEADER, $http_headers);
        }
        
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // uncomment this line if you get no gateway response. ###
        
        $resp = curl_exec($ch);
        curl_close ($ch);

        return $resp;
    }
    
    /**
     * Simple logger 
     * 
     * @param string $text
     * @param string $type
     * @return void
     */
    function _log($text, $type = 'message')
    {
        if ($this->_isLog) {
            $file = JPATH_ROOT . "/cache/{$this->_element}.log";
            $date = JFactory::getDate();
            
            $f = fopen($file, 'a');
            fwrite($f, "\n\n" . $date->toFormat('%Y-%m-%d %H:%M:%S'));
            fwrite($f, "\n" . $type . ': ' . $text);            
            fclose($f);
        }   
    }
        
    /**
     * Processes a simple (non-recurring payment)
     * by sending data to auth.net and interpreting the response
     * and managing the order as required
     *
     * @param array $authnet_values  
     * @return string
     * @access protected
     */
    function _processSimplePayment($authnet_values) 
    {
        $html = '';
        
        // prepare the array for posting to authorize.net
        $fields = '';
        foreach( $authnet_values as $key => $value ) {
            $fields .= "$key=" . urlencode( $value ) . "&"; 
        }
            
        // send a request
        $resp = $this->_sendRequest($this->_getActionUrl('simple'), rtrim( $fields, "& " ));
        $this->_log($resp);
        
        // evaluate the response
        $evaluateResponse = $this->_evaluateSimplePaymentResponse( $resp, $authnet_values );
        $html = $evaluateResponse;

        return $html;
    }
    
    /**
     * Proceeds the simple payment
     * 
     * @param string $resp
     * @param array $submitted_values
     * @return object Message object
     * @access protected
     */
    function _evaluateSimplePaymentResponse( $resp, $submitted_values )
    {
        $object = new JObject();
        $object->message = '';
        $html = '';
        $errors = array();
        $payment_status = 'Incomplete';
        $order_status = '0';

        $auth_x_delim_char          = "|";              # not to be changed
        $user =& JFactory::getUser();
        
        if ( !$user->id) {
            $errors[] = JText::_('AuthorizeDotNet Message Unknown User');
            $user->set('id', 0);
        }
        
        // Evaluate a typical response from auth.net
        $exploded = explode( $auth_x_delim_char, $resp );
        for ($i=0; $i<count($exploded); $i++)
        {
            $value = $exploded[$i]; 
    
            if ($value == "") {
                $value = "NO VALUE RETURNED";
            }
            
            $key = $i + 1;          
            switch ($key) 
            {
                case 1:
                    // Response Code
                    $paymentResponse = $value;
                    switch ($value) 
                    {
                        case "1":
                            // Approved
                            $payment_status = JText::_('Completed');
                          break;
                        case "2":
                            // Declined
                            $payment_status = JText::_('Declined');
                            $order_status = '0';
                            $errors[] = JText::_( "Card was declined" );
                          break;
                        case "3":
                        default:
                            // Error
                            $payment_status = JText::_('Error');
                            $order_status = '0';
                            $errors[] = JText::_( "Error processing payment" );
                          break;
                    }
                  break;
                case 2:
                    // Response Subcode
                    $subcodeResponse = $value;
                    break;  
                case 3:
                    // Response Reason Code
                    $reasoncodeResponse = $value;
                    break;  
                case 4:
                    // Response Reason Text
                    $reasonResponse = $value;
                    break;  
                case 5:
                    // Approval Code
                    $approvalcodeResponse = $value;
                    break;  
                case 6:
                    // AVS Result Code
                    $avsResponse = $value;
                    break;  
                case 7:
                    // Transaction ID
                    $transactionidResponse = $value;
                    break;  
                case 8:
                    // Invoice Number (x_invoice_num)
                    $invoiceResponse = $value;
                    break;  
                case 9:
                    // Description (x_description)
                    $descriptionResponse = $value;
                    break;  
                case 10:
                    // Amount (x_amount)
                    $amountResponse = $value;
                    break;  
                case 11:
                    // Method (x_method)
                    $methodResponse = $value;
                    break;  
                case 12:
                    // Transaction Type (x_type)
                    $transactiontypeResponse = $value;
                    break;  
                case 13:
                    // Customer ID (x_cust_id)
                    $customeridResponse = $value;
                    break;  
                case 14:
                    // Cardholder First Name (x_first_name)
                    $fnameResponse = $value;
                    break;  
                case 15:
                    // Cardholder Last Name (x_last_name)
                    $lnameResponse = $value;
                    break;  
                case 16:
                    // Company (x_company)
                    $companyResponse = $value;
                    break;  
                case 17:
                    // Billing Address (x_address)
                    $addressResponse = $value;
                    break;  
                case 18:
                    // City (x_city)
                    $cityResponse = $value;
                    break;  
                case 19:
                    // State (x_state)
                    $stateResponse = $value;
                    break;  
                case 20:
                    // ZIP (x_zip)
                    $zipResponse = $value;
                    break;  
                case 21:
                    // Country (x_country)
                    $countryResponse = $value;
                    break;  
                case 22:
                    // Phone (x_phone)
                    $phoneResponse = $value;
                    break;  
                case 23:
                    // Fax (x_fax)
                    $faxResponse = $value;
                    break;  
                case 24:
                    // E-Mail Address (x_email)
                    $emailResponse = $value;
                    break;  
                case 25:
                    // Ship to First Name (x_ship_to_first_name)
                    $shipfnameResponse = $value;
                    break;  
                case 26:
                    // Ship to Last Name (x_ship_to_last_name)
                    $shiplnameResponse = $value;
                    break;  
                case 27:
                    // Ship to Company (x_ship_to_company)
                    $shipcompanyResponse = $value;
                    break;  
                case 28:
                    // Ship to Address (x_ship_to_address)
                    $shipaddressResponse = $value;
                    break;  
                case 29:
                    // Ship to City (x_ship_to_city)
                    $shipcityResponse = $value;
                    break;  
                case 30:
                    // Ship to State (x_ship_to_state)
                    $shipstateResponse = $value;
                    break;  
                case 31:
                    // Ship to ZIP (x_ship_to_zip)
                    $shipzipResponse = $value;
                    break;  
                case 32:
                    // Ship to Country (x_ship_to_country)
                    $shipcountryResponse = $value;
                    break;  
                case 33:
                    // Tax Amount (x_tax)
                    $taxResponse = $value;
                    break;  
                case 34:
                    // Duty Amount (x_duty)
                    $dutyResponse = $value;
                    break;  
                case 35:
                    // Freight Amount (x_freight)
                    $freightResponse = $value;
                    break;  
                case 36:
                    // Tax Exempt Flag (x_tax_exempt)
                    $taxexemptResponse = $value;
                    break;  
                case 37:
                    // PO Number (x_po_num)
                    $ponumResponse = $value;
                    break;  
                case 38:
                    // MD5 Hash
                    $md5hashResponse = $value;
                    break;  
                case 39:
                    // Card Code Response (CVV)
                    $cvvResponse = $value;
                    switch ($value) 
                    {
                        case "M":
                            // Match
                            $cvv_status = '1';
                          break;
                        case "N":
                            // NO Match
                            $cvv_status = '0';
                          break;
                        case "P":
                            // Not Processed
                            $cvv_status = '0';
                          break;
                        case "S":
                            // Should have been present
                            $cvv_status = '0';
                          break;
                        case "U":
                            // Issuer unable to process request
                            $cvv_status = '0';
                          break;
                        default:
                            // No Value returned
                            $cvv_status = null;
                          break;
                    }
                    break;  
                case 40:
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 64:
                case 65:
                case 66:
                case 67:
                case 68:
                    // Reserved by auth.net
                    break;  
                default:
                    // if here, then $key is not one of the reserved 68 fields
                    // we're now processing custom fields sent through auth.net and back to us
                    // such as itemTypeid, paymentType, and cardtype
                    switch ($key) 
                    {
                        case "k2store_orderpayment_id":
                            $orderpayment_id = $value;
                          break;
                        default:
                            // orphan key
                          break;
                    }
                    break;
            }
        }
        
        // =======================
        // verify & create payment
        // =======================
			require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'utilities.php');

            // check that payment amount is correct for order_id
            JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'tables' );
            $orderpayment = JTable::getInstance('Orders', 'Table');
            $orderpayment->load( $invoiceResponse );
            if (empty($orderpayment->order_id))
            {
                // TODO fail
            }
            $orderpayment->transaction_details  = $resp;
            $orderpayment->transaction_id       = $transactionidResponse;
            $orderpayment->transaction_status   = $payment_status;

            $stored_amount = K2StoreUtilities::number( $orderpayment->get('orderpayment_amount'), array( 'thousands'=>'', 'num_decimals'=>'2' ) );
            $respond_amount = K2StoreUtilities::number( $amountResponse, array( 'thousands'=>'', 'num_decimals'=>'2' ) );
            if ($stored_amount != $respond_amount ) {
                $errors[] = JText::_('K2STORE AUTHORIZEDOTNET MESSAGE PAYMENT AMOUNT INVALID');
                $errors[] = $stored_amount . " != " . $respond_amount;
            }
            
            //set a default status to it
			$orderpayment->order_state = JText::_('PENDING'); // FAILED
        
            // set the order's new status and update quantities if necessary
            if (count($errors)) 
            {
                // if an error occurred 
                $orderpayment->order_state = trim(JText::_('FAILED')); // FAILED 
            }
                else 
            {
				$orderpayment->order_state = trim(JText::_('CONFIRMED')); // Payment received and CONFIRMED
				$this->setOrderPaymentReceived( $orderpayment->order_id );
            }
    
            // save the order
            if (!$orderpayment->store())
            {
                $errors[] = $orderpayment->getError();
            }
            
            if (empty($errors))
            {
				// let us inform the user that the payment is successful
				require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'orders.php');
				K2StoreOrdersHelper::sendUserEmail($orderpayment->user_id, $orderpayment->order_id, $orderpayment->order_state, $orderpayment->order_state);

                $return = JText::_( "K2STORE AUTHORIZEDOTNET MESSAGE PAYMENT SUCCESS" );
                return $return;                
            }
            
            
            return count($errors) ? implode("\n", $errors) : '';

        // ===================
        // end custom code
        // ===================
    }

}
