<?php
/*------------------------------------------------------------------------
 # com_k2store - K2 Store
# ------------------------------------------------------------------------
# author    Ramesh Elamathi - Weblogicx India http://www.weblogicxindia.com
# copyright Copyright (C) 2012 Weblogicxindia.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://k2store.org
# Technical Support:  Forum - http://k2store.org/forum/index.html
-------------------------------------------------------------------------*/


// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport('joomla.html.parameter');

class plgSystemK2Store extends JPlugin {

	function plgSystemK2Store( &$subject, $config ){
		parent::__construct( $subject, $config );
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'k2store' );
		$params = new JRegistry;
		$params->loadString($this->_plugin->params );
		$this->_params = $params;

		//load default language
		$lang = JFactory::getLanguage();
		$lang->load('com_k2store', JPATH_SITE);
	}

	function onAfterRoute() {

		$mainframe = JFactory::getApplication();
		require_once (JPATH_ADMINISTRATOR.'/components/com_k2store/library/popup.php');
		require_once (JPATH_SITE.'/components/com_k2store/helpers/modules.php');
		JHtml::_('behavior.framework');
		JHtml::_('behavior.modal');
		$baseURL = JURI::root();
		$k2storeparams = JComponentHelper::getParams('com_k2store');
		$document =JFactory::getDocument();

		if(version_compare(JVERSION, '3.0', 'ge')) {
			//load jquery if version is 3.0
			// Joomla! 3.0 and later, use Joomla! code to load the library
			JHtml::_('jquery.framework');
			//load jquery UI
			//JHtml::_('jquery.ui');
		}else {
			//load jquery for joomla 2.5/ local/remote
			if($k2storeparams->get('k2store_load_jquery', 1) == 1) {
				//load from local
				$document->addScript(JURI::root(true).'/media/k2store/js/jquery.min.js');
			} elseif ($k2storeparams->get('k2store_load_jquery', 1) == 2) {
				//load from remote
				$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js');
			}
		}

		if((version_compare(JVERSION, '3.0', 'lt') && $mainframe->isAdmin()) || $mainframe->isSite()) {

			//load jquery UI
			if($k2storeparams->get('k2store_load_jqueryui', 1) == 1) {
				$document->addScript(JURI::root(true).'/media/k2store/js/jquery-ui-1.10.2.custom.min.js');
			}elseif($k2storeparams->get('k2store_load_jqueryui', 1) == 2) {
				$document->addScript('https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.2/jquery-ui.min.js');
			}
		}


		$script = "
		if(typeof(K2Store) == 'undefined') {
		var K2Store = jQuery.noConflict();
		}";

		$document->addScriptDeclaration($script);
		$document->addScript(JURI::root(true).'/media/k2store/js/jquery.validate.min.js');
		$document->addScriptDeclaration("var k2storeURL = '$baseURL';");

		if($mainframe->isAdmin()) {
			//add additional css if it is version 2.5
			if (!version_compare(JVERSION, '3.0', 'ge'))
			{
				$document->addScript(JURI::root(true).'/media/k2store/js/bootstrap.min.js');
				$document->addStyleSheet(JURI::root(true).'/media/k2store/css/bootstrap.min.css');
			}

			$document->addScript(JURI::root(true).'/media/k2store/js/k2store_admin.js');
			$document->addStyleSheet(JURI::root(true).'/media/k2store/css/k2store_admin.css');

		}
		else {
		$document->addScript(JUri::root(true).'/media/k2store/js/jquery-ui-timepicker-addon.js');
		$document->addStyleSheet(JURI::root(true).'/media/k2store/css/jquery-ui-custom.css');
		$document->addScript(JURI::root(true).'/media/k2store/js/k2store.js');

		// Add related CSS to the <head>
		if ($document->getType() == 'html' && $k2storeparams->get('k2store_enable_css')) {

			jimport('joomla.filesystem.file');

			// k2store.css
			if(JFile::exists(JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'css'.DS.'k2store.css'))
				$document->addStyleSheet($baseURL.'templates/'.$mainframe->getTemplate().'/css/k2store.css');
			else
				$document->addStyleSheet($baseURL.'media/k2store/css/k2store.css');
			if (!version_compare(JVERSION, '3.0', 'ge'))
			{
				$document->addStyleSheet($baseURL.'media/k2store/css/bootstrap.min.css');
			}

		} else {
			$document->addStyleSheet($baseURL.'media/k2store/css/k2store.css');

			if (!version_compare(JVERSION, '3.0', 'ge'))
			{
				$document->addStyleSheet($baseURL.'media/k2store/css/bootstrap.min.css');
			}
		}

		$this->_addCartJS();

		}  //end of if condition


	} //end of function

	function _addCartJS() {

		$document =JFactory::getDocument();

		//initialise the date/time picker

		//localisation
		$currentText = JText::_('K2STORE_TIMEPICKER_JS_CURRENT_TEXT');
		$closeText = JText::_('K2STORE_TIMEPICKER_JS_CLOSE_TEXT');
		$timeOnlyText = JText::_('K2STORE_TIMEPICKER_JS_CHOOSE_TIME');
		$timeText = JText::_('K2STORE_TIMEPICKER_JS_TIME');
		$hourText = JText::_('K2STORE_TIMEPICKER_JS_HOUR');
		$minuteText = JText::_('K2STORE_TIMEPICKER_JS_MINUTE');
		$secondText = JText::_('K2STORE_TIMEPICKER_JS_SECOND');
		$millisecondText = JText::_('K2STORE_TIMEPICKER_JS_MILLISECOND');
		$timezoneText = JText::_('K2STORE_TIMEPICKER_JS_TIMEZONE');

		$localisation ="
		currentText: '$currentText',
		closeText: '$closeText',
		timeOnlyTitle: '$timeOnlyText',
		timeText: '$timeText',
		hourText: '$hourText',
		minuteText: '$minuteText',
		secondText: '$secondText',
		millisecText: '$millisecondText',
		timezoneText: '$timezoneText'
		";

		$timepicker_script ="
		K2Store(document).ready(function(){
			//date, time, datetime
			if (K2Store.browser.msie && K2Store.browser.version == 6) {
				K2Store('.k2store_date, .k2store_datetime, .k2store_time').bgIframe();
			}

			K2Store('.k2store_date').datepicker({dateFormat: 'yy-mm-dd'});
			K2Store('.k2store_datetime').datetimepicker({
				dateFormat: 'yy-mm-dd',
				timeFormat: 'HH:mm',
				$localisation
			});

			K2Store('.k2store_time').timepicker({timeFormat: 'HH:mm', $localisation});

		});
		";
		$document->addScriptDeclaration($timepicker_script);

	}

}
